Animated={}
__timerArg=__timerArg or {}

timerEx=timerEx or function(ms,func,count,...)
	count=count or 1
	if count==0 then count=-1 end
	local tmpfunc,id="",0
	local random=math.random
	local char=string.char
	for i=1,8 do
		local rand=random(0,2)
		if rand==0 then
			tmpfunc=tmpfunc..char(random(65,90))
		elseif rand==1 then
			tmpfunc=tmpfunc..char(random(97,112))
		else
			tmpfunc=tmpfunc..random(0,9)
		end
	end
	table.insert(__timerArg,{type(func),tmpfunc,func,{...},count})
	for n,v in pairs(__timerArg) do
		if v[2]==tmpfunc then
			id=n
			break
		end
	end
	_G[tmpfunc]=function(id)
		id=tonumber(id)
		local ta=__timerArg
		if ta[id][1]=="function" then
			ta[id].r=ta[id][3](unpack(ta[id][4]))
		elseif ta[id][1]=="string" or ta[id][1]=="number" then
			ta[id].r=loadstring("return "..ta[id][3].."(unpack(ta["..id.."][4]))")()
		end
		ta[id][5]=ta[id][5]-1
		if ta[id][5]==0 then
			_G[ta[id][2]]=nil
			ta[id]=nil
		end
	end
	timer(ms,tmpfunc,id,count)
	return id
end

freetimerEx=freetimerEx or function(id)
	local ta=__timerArg
	if ta[id]~=nil then
		freetimer(ta[id][2],id)
		_G[ta[id][2]]=nil
		ta[id]=nil
		return true
	end
	return false
end

function imageanimated(folder,usemeta,filepattern,x,y,mode,pl,speed)
	pl=pl or 0
	local filecount=0
	local foldermode=0
	local function getMode(f)
		local temp=io.open(folder.."/"..f,"r")
		if temp==nil then
			foldermode=1
			return io.open(folder..f,"r")
		else
			return temp
		end
	end
	local meta
	if usemeta then
		meta=getMode("meta.txt")
	end
	if meta then
		local a=0
		for line in meta:lines() do
			a=a+1
			if a==1 then
				filepattern=filepattern or line
			elseif a==2 then
				for m,s in line:gmatch("(%d+) (%d+)") do
					mode=mode or m
					speed=speed or s
				end
			end
		end
		meta:close()
	end
	speed=speed or 100
	while true do
		filecount=filecount+1
		local temp=io.open(folder.."/"..filepattern:format(filecount),"r") or io.open(folder..filepattern:format(filecount),"r")
		if temp==nil then
			filecount=filecount-1
			break
		end
		temp:close()
	end
	if filecount==0 then
		print("\169255000000Image Animated: No files found!")
		return 0
	end
	local iid
	local temp={{},0,1}
	if foldermode==0 then
		for i=1,filecount do
			iid=image(folder.."/"..filepattern:format(i),x,y,mode,pl)
			if iid==0 then
				print("\169255000000Image Animated: Cannot Load "..filepattern:format(i))
				return 0
			end
			imagealpha(iid,0)
			table.insert(temp[1],iid)
		end
	else
		for i=1,filecount do
			iid=image(folder..filepattern:format(i),x,y,mode,pl)
			if iid==0 then
				print("\169255000000Image Animated: Cannot Load "..filepattern:format(i))
				return 0
			end
			imagealpha(iid,0)
			table.insert(temp[1],iid)
		end
	end
	temp[3]=1
	table.insert(Animated,temp)
	local id=0
	for n,v in pairs(Animated) do
		if v==temp then
			id=n
			break
		end
	end
	if id==0 then
		print("\169255000000Image Animated: Unknown Error")
		return 0
	end
	temp[2]=timerEx(speed,loadstring("local n,p=0,Animated["..id.."][3] if p==#Animated["..id.."][1] then n=1 else n=p+1 end imagealpha(Animated["..id.."][1][n],1) imagealpha(Animated["..id.."][1][p],0) Animated["..id.."][3]=n"),-1)
	if temp[2]==0 then
		print("\169255000000Image Animated: timerEx Error!")
		return 0
	end
	imagealpha(temp[1][1],1)
	return id
end

function imageanimatedpos(id,x,y,rot)
	local Animated=Animated
	if Animated[id] then
		rot=rot or 0
		for n,v in pairs(Animated[id][1]) do
			imagepos(v,x,y,rot)
		end
	end
end

function freeimageanimated(i)
	if Animated[i] then
		for n,v in pairs(Animated[i][1]) do
			freeimage(v)
		end
		freetimerEx(Animated[i][2])
		Animated[i]=nil
	end
end

addhook("startround","destroy_animated")
function destroy_animated()
	for n,v in pairs(Animated) do
		freeimageanimated(n)
	end
end